<?php declare(strict_types=1);

namespace Infomaker\Everyware\Base;

use Infomaker\Everyware\Support\Str;

/**
 * JsonImporter
 *
 * @link    http://infomaker.se
 * @package Infomaker\Everyware\Handler
 * @since   Infomaker\Everyware\Base\JsonImporter 1.0.0
 */
class JsonImporter
{
    public const POST_KEY = 'imported-data';

    /**
     * @var string
     */
    protected $submit_name;

    public function __construct(string $submit_name = '')
    {
        $this->submit_name = Str::notEmpty($submit_name) ? Str::slug($submit_name) : self::POST_KEY;
    }

    public function isImported(): bool
    {
        return isset($_POST[$this->submit_name]);
    }

    public function getJson(): array
    {
        if ($this->isImported()) {
            $data = json_decode($this->getRawJson(), true);

            return $data !== null ? array_filter($data) : [];
        }

        return [];
    }

    public function getRawJson(): string
    {
        if ($this->isImported()) {
            return stripslashes($_POST[$this->submit_name]);
        }

        return '';
    }
}
